import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { AssociatePackageRequest, AssociatePackageResponse } from "../models/models_0";
import { deserializeAws_restJson1AssociatePackageCommand, serializeAws_restJson1AssociatePackageCommand, } from "../protocols/Aws_restJson1";
var AssociatePackageCommand = (function (_super) {
    __extends(AssociatePackageCommand, _super);
    function AssociatePackageCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    AssociatePackageCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "ElasticsearchServiceClient";
        var commandName = "AssociatePackageCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: AssociatePackageRequest.filterSensitiveLog,
            outputFilterSensitiveLog: AssociatePackageResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    AssociatePackageCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1AssociatePackageCommand(input, context);
    };
    AssociatePackageCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1AssociatePackageCommand(output, context);
    };
    return AssociatePackageCommand;
}($Command));
export { AssociatePackageCommand };
