import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { CreateElasticsearchDomainRequest, CreateElasticsearchDomainResponse } from "../models/models_0";
import { deserializeAws_restJson1CreateElasticsearchDomainCommand, serializeAws_restJson1CreateElasticsearchDomainCommand, } from "../protocols/Aws_restJson1";
var CreateElasticsearchDomainCommand = (function (_super) {
    __extends(CreateElasticsearchDomainCommand, _super);
    function CreateElasticsearchDomainCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    CreateElasticsearchDomainCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "ElasticsearchServiceClient";
        var commandName = "CreateElasticsearchDomainCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: CreateElasticsearchDomainRequest.filterSensitiveLog,
            outputFilterSensitiveLog: CreateElasticsearchDomainResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    CreateElasticsearchDomainCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1CreateElasticsearchDomainCommand(input, context);
    };
    CreateElasticsearchDomainCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1CreateElasticsearchDomainCommand(output, context);
    };
    return CreateElasticsearchDomainCommand;
}($Command));
export { CreateElasticsearchDomainCommand };
