import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { CreatePackageRequest, CreatePackageResponse } from "../models/models_0";
import { deserializeAws_restJson1CreatePackageCommand, serializeAws_restJson1CreatePackageCommand, } from "../protocols/Aws_restJson1";
var CreatePackageCommand = (function (_super) {
    __extends(CreatePackageCommand, _super);
    function CreatePackageCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    CreatePackageCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "ElasticsearchServiceClient";
        var commandName = "CreatePackageCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: CreatePackageRequest.filterSensitiveLog,
            outputFilterSensitiveLog: CreatePackageResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    CreatePackageCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1CreatePackageCommand(input, context);
    };
    CreatePackageCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1CreatePackageCommand(output, context);
    };
    return CreatePackageCommand;
}($Command));
export { CreatePackageCommand };
