import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { deserializeAws_restJson1DeleteElasticsearchServiceRoleCommand, serializeAws_restJson1DeleteElasticsearchServiceRoleCommand, } from "../protocols/Aws_restJson1";
var DeleteElasticsearchServiceRoleCommand = (function (_super) {
    __extends(DeleteElasticsearchServiceRoleCommand, _super);
    function DeleteElasticsearchServiceRoleCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DeleteElasticsearchServiceRoleCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "ElasticsearchServiceClient";
        var commandName = "DeleteElasticsearchServiceRoleCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: function (input) { return input; },
            outputFilterSensitiveLog: function (output) { return output; },
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DeleteElasticsearchServiceRoleCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1DeleteElasticsearchServiceRoleCommand(input, context);
    };
    DeleteElasticsearchServiceRoleCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1DeleteElasticsearchServiceRoleCommand(output, context);
    };
    return DeleteElasticsearchServiceRoleCommand;
}($Command));
export { DeleteElasticsearchServiceRoleCommand };
