import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DeleteOutboundCrossClusterSearchConnectionRequest, DeleteOutboundCrossClusterSearchConnectionResponse, } from "../models/models_0";
import { deserializeAws_restJson1DeleteOutboundCrossClusterSearchConnectionCommand, serializeAws_restJson1DeleteOutboundCrossClusterSearchConnectionCommand, } from "../protocols/Aws_restJson1";
var DeleteOutboundCrossClusterSearchConnectionCommand = (function (_super) {
    __extends(DeleteOutboundCrossClusterSearchConnectionCommand, _super);
    function DeleteOutboundCrossClusterSearchConnectionCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DeleteOutboundCrossClusterSearchConnectionCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "ElasticsearchServiceClient";
        var commandName = "DeleteOutboundCrossClusterSearchConnectionCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DeleteOutboundCrossClusterSearchConnectionRequest.filterSensitiveLog,
            outputFilterSensitiveLog: DeleteOutboundCrossClusterSearchConnectionResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DeleteOutboundCrossClusterSearchConnectionCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1DeleteOutboundCrossClusterSearchConnectionCommand(input, context);
    };
    DeleteOutboundCrossClusterSearchConnectionCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1DeleteOutboundCrossClusterSearchConnectionCommand(output, context);
    };
    return DeleteOutboundCrossClusterSearchConnectionCommand;
}($Command));
export { DeleteOutboundCrossClusterSearchConnectionCommand };
