import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DeletePackageRequest, DeletePackageResponse } from "../models/models_0";
import { deserializeAws_restJson1DeletePackageCommand, serializeAws_restJson1DeletePackageCommand, } from "../protocols/Aws_restJson1";
var DeletePackageCommand = (function (_super) {
    __extends(DeletePackageCommand, _super);
    function DeletePackageCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DeletePackageCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "ElasticsearchServiceClient";
        var commandName = "DeletePackageCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DeletePackageRequest.filterSensitiveLog,
            outputFilterSensitiveLog: DeletePackageResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DeletePackageCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1DeletePackageCommand(input, context);
    };
    DeletePackageCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1DeletePackageCommand(output, context);
    };
    return DeletePackageCommand;
}($Command));
export { DeletePackageCommand };
