import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DescribeDomainChangeProgressRequest, DescribeDomainChangeProgressResponse } from "../models/models_0";
import { deserializeAws_restJson1DescribeDomainChangeProgressCommand, serializeAws_restJson1DescribeDomainChangeProgressCommand, } from "../protocols/Aws_restJson1";
var DescribeDomainChangeProgressCommand = (function (_super) {
    __extends(DescribeDomainChangeProgressCommand, _super);
    function DescribeDomainChangeProgressCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DescribeDomainChangeProgressCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "ElasticsearchServiceClient";
        var commandName = "DescribeDomainChangeProgressCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DescribeDomainChangeProgressRequest.filterSensitiveLog,
            outputFilterSensitiveLog: DescribeDomainChangeProgressResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DescribeDomainChangeProgressCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1DescribeDomainChangeProgressCommand(input, context);
    };
    DescribeDomainChangeProgressCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1DescribeDomainChangeProgressCommand(output, context);
    };
    return DescribeDomainChangeProgressCommand;
}($Command));
export { DescribeDomainChangeProgressCommand };
