import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DescribeElasticsearchDomainRequest, DescribeElasticsearchDomainResponse } from "../models/models_0";
import { deserializeAws_restJson1DescribeElasticsearchDomainCommand, serializeAws_restJson1DescribeElasticsearchDomainCommand, } from "../protocols/Aws_restJson1";
var DescribeElasticsearchDomainCommand = (function (_super) {
    __extends(DescribeElasticsearchDomainCommand, _super);
    function DescribeElasticsearchDomainCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DescribeElasticsearchDomainCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "ElasticsearchServiceClient";
        var commandName = "DescribeElasticsearchDomainCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DescribeElasticsearchDomainRequest.filterSensitiveLog,
            outputFilterSensitiveLog: DescribeElasticsearchDomainResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DescribeElasticsearchDomainCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1DescribeElasticsearchDomainCommand(input, context);
    };
    DescribeElasticsearchDomainCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1DescribeElasticsearchDomainCommand(output, context);
    };
    return DescribeElasticsearchDomainCommand;
}($Command));
export { DescribeElasticsearchDomainCommand };
