import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DescribeElasticsearchInstanceTypeLimitsRequest, DescribeElasticsearchInstanceTypeLimitsResponse, } from "../models/models_0";
import { deserializeAws_restJson1DescribeElasticsearchInstanceTypeLimitsCommand, serializeAws_restJson1DescribeElasticsearchInstanceTypeLimitsCommand, } from "../protocols/Aws_restJson1";
var DescribeElasticsearchInstanceTypeLimitsCommand = (function (_super) {
    __extends(DescribeElasticsearchInstanceTypeLimitsCommand, _super);
    function DescribeElasticsearchInstanceTypeLimitsCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DescribeElasticsearchInstanceTypeLimitsCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "ElasticsearchServiceClient";
        var commandName = "DescribeElasticsearchInstanceTypeLimitsCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DescribeElasticsearchInstanceTypeLimitsRequest.filterSensitiveLog,
            outputFilterSensitiveLog: DescribeElasticsearchInstanceTypeLimitsResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DescribeElasticsearchInstanceTypeLimitsCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1DescribeElasticsearchInstanceTypeLimitsCommand(input, context);
    };
    DescribeElasticsearchInstanceTypeLimitsCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1DescribeElasticsearchInstanceTypeLimitsCommand(output, context);
    };
    return DescribeElasticsearchInstanceTypeLimitsCommand;
}($Command));
export { DescribeElasticsearchInstanceTypeLimitsCommand };
