import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DescribeInboundCrossClusterSearchConnectionsRequest, DescribeInboundCrossClusterSearchConnectionsResponse, } from "../models/models_0";
import { deserializeAws_restJson1DescribeInboundCrossClusterSearchConnectionsCommand, serializeAws_restJson1DescribeInboundCrossClusterSearchConnectionsCommand, } from "../protocols/Aws_restJson1";
var DescribeInboundCrossClusterSearchConnectionsCommand = (function (_super) {
    __extends(DescribeInboundCrossClusterSearchConnectionsCommand, _super);
    function DescribeInboundCrossClusterSearchConnectionsCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DescribeInboundCrossClusterSearchConnectionsCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "ElasticsearchServiceClient";
        var commandName = "DescribeInboundCrossClusterSearchConnectionsCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DescribeInboundCrossClusterSearchConnectionsRequest.filterSensitiveLog,
            outputFilterSensitiveLog: DescribeInboundCrossClusterSearchConnectionsResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DescribeInboundCrossClusterSearchConnectionsCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1DescribeInboundCrossClusterSearchConnectionsCommand(input, context);
    };
    DescribeInboundCrossClusterSearchConnectionsCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1DescribeInboundCrossClusterSearchConnectionsCommand(output, context);
    };
    return DescribeInboundCrossClusterSearchConnectionsCommand;
}($Command));
export { DescribeInboundCrossClusterSearchConnectionsCommand };
