import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { DescribePackagesRequest, DescribePackagesResponse } from "../models/models_0";
import { deserializeAws_restJson1DescribePackagesCommand, serializeAws_restJson1DescribePackagesCommand, } from "../protocols/Aws_restJson1";
var DescribePackagesCommand = (function (_super) {
    __extends(DescribePackagesCommand, _super);
    function DescribePackagesCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    DescribePackagesCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "ElasticsearchServiceClient";
        var commandName = "DescribePackagesCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: DescribePackagesRequest.filterSensitiveLog,
            outputFilterSensitiveLog: DescribePackagesResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    DescribePackagesCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1DescribePackagesCommand(input, context);
    };
    DescribePackagesCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1DescribePackagesCommand(output, context);
    };
    return DescribePackagesCommand;
}($Command));
export { DescribePackagesCommand };
