import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { GetCompatibleElasticsearchVersionsRequest, GetCompatibleElasticsearchVersionsResponse, } from "../models/models_0";
import { deserializeAws_restJson1GetCompatibleElasticsearchVersionsCommand, serializeAws_restJson1GetCompatibleElasticsearchVersionsCommand, } from "../protocols/Aws_restJson1";
var GetCompatibleElasticsearchVersionsCommand = (function (_super) {
    __extends(GetCompatibleElasticsearchVersionsCommand, _super);
    function GetCompatibleElasticsearchVersionsCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    GetCompatibleElasticsearchVersionsCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "ElasticsearchServiceClient";
        var commandName = "GetCompatibleElasticsearchVersionsCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: GetCompatibleElasticsearchVersionsRequest.filterSensitiveLog,
            outputFilterSensitiveLog: GetCompatibleElasticsearchVersionsResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    GetCompatibleElasticsearchVersionsCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1GetCompatibleElasticsearchVersionsCommand(input, context);
    };
    GetCompatibleElasticsearchVersionsCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1GetCompatibleElasticsearchVersionsCommand(output, context);
    };
    return GetCompatibleElasticsearchVersionsCommand;
}($Command));
export { GetCompatibleElasticsearchVersionsCommand };
