import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { GetPackageVersionHistoryRequest, GetPackageVersionHistoryResponse } from "../models/models_0";
import { deserializeAws_restJson1GetPackageVersionHistoryCommand, serializeAws_restJson1GetPackageVersionHistoryCommand, } from "../protocols/Aws_restJson1";
var GetPackageVersionHistoryCommand = (function (_super) {
    __extends(GetPackageVersionHistoryCommand, _super);
    function GetPackageVersionHistoryCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    GetPackageVersionHistoryCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "ElasticsearchServiceClient";
        var commandName = "GetPackageVersionHistoryCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: GetPackageVersionHistoryRequest.filterSensitiveLog,
            outputFilterSensitiveLog: GetPackageVersionHistoryResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    GetPackageVersionHistoryCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1GetPackageVersionHistoryCommand(input, context);
    };
    GetPackageVersionHistoryCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1GetPackageVersionHistoryCommand(output, context);
    };
    return GetPackageVersionHistoryCommand;
}($Command));
export { GetPackageVersionHistoryCommand };
