import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { GetUpgradeHistoryRequest, GetUpgradeHistoryResponse } from "../models/models_0";
import { deserializeAws_restJson1GetUpgradeHistoryCommand, serializeAws_restJson1GetUpgradeHistoryCommand, } from "../protocols/Aws_restJson1";
var GetUpgradeHistoryCommand = (function (_super) {
    __extends(GetUpgradeHistoryCommand, _super);
    function GetUpgradeHistoryCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    GetUpgradeHistoryCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "ElasticsearchServiceClient";
        var commandName = "GetUpgradeHistoryCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: GetUpgradeHistoryRequest.filterSensitiveLog,
            outputFilterSensitiveLog: GetUpgradeHistoryResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    GetUpgradeHistoryCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1GetUpgradeHistoryCommand(input, context);
    };
    GetUpgradeHistoryCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1GetUpgradeHistoryCommand(output, context);
    };
    return GetUpgradeHistoryCommand;
}($Command));
export { GetUpgradeHistoryCommand };
