import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { ListDomainsForPackageRequest, ListDomainsForPackageResponse } from "../models/models_0";
import { deserializeAws_restJson1ListDomainsForPackageCommand, serializeAws_restJson1ListDomainsForPackageCommand, } from "../protocols/Aws_restJson1";
var ListDomainsForPackageCommand = (function (_super) {
    __extends(ListDomainsForPackageCommand, _super);
    function ListDomainsForPackageCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    ListDomainsForPackageCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "ElasticsearchServiceClient";
        var commandName = "ListDomainsForPackageCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: ListDomainsForPackageRequest.filterSensitiveLog,
            outputFilterSensitiveLog: ListDomainsForPackageResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    ListDomainsForPackageCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1ListDomainsForPackageCommand(input, context);
    };
    ListDomainsForPackageCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1ListDomainsForPackageCommand(output, context);
    };
    return ListDomainsForPackageCommand;
}($Command));
export { ListDomainsForPackageCommand };
