import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { PurchaseReservedElasticsearchInstanceOfferingRequest, PurchaseReservedElasticsearchInstanceOfferingResponse, } from "../models/models_0";
import { deserializeAws_restJson1PurchaseReservedElasticsearchInstanceOfferingCommand, serializeAws_restJson1PurchaseReservedElasticsearchInstanceOfferingCommand, } from "../protocols/Aws_restJson1";
var PurchaseReservedElasticsearchInstanceOfferingCommand = (function (_super) {
    __extends(PurchaseReservedElasticsearchInstanceOfferingCommand, _super);
    function PurchaseReservedElasticsearchInstanceOfferingCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    PurchaseReservedElasticsearchInstanceOfferingCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "ElasticsearchServiceClient";
        var commandName = "PurchaseReservedElasticsearchInstanceOfferingCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: PurchaseReservedElasticsearchInstanceOfferingRequest.filterSensitiveLog,
            outputFilterSensitiveLog: PurchaseReservedElasticsearchInstanceOfferingResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    PurchaseReservedElasticsearchInstanceOfferingCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1PurchaseReservedElasticsearchInstanceOfferingCommand(input, context);
    };
    PurchaseReservedElasticsearchInstanceOfferingCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1PurchaseReservedElasticsearchInstanceOfferingCommand(output, context);
    };
    return PurchaseReservedElasticsearchInstanceOfferingCommand;
}($Command));
export { PurchaseReservedElasticsearchInstanceOfferingCommand };
