import { __extends } from "tslib";
import { getSerdePlugin } from "@aws-sdk/middleware-serde";
import { Command as $Command } from "@aws-sdk/smithy-client";
import { UpgradeElasticsearchDomainRequest, UpgradeElasticsearchDomainResponse } from "../models/models_0";
import { deserializeAws_restJson1UpgradeElasticsearchDomainCommand, serializeAws_restJson1UpgradeElasticsearchDomainCommand, } from "../protocols/Aws_restJson1";
var UpgradeElasticsearchDomainCommand = (function (_super) {
    __extends(UpgradeElasticsearchDomainCommand, _super);
    function UpgradeElasticsearchDomainCommand(input) {
        var _this = _super.call(this) || this;
        _this.input = input;
        return _this;
    }
    UpgradeElasticsearchDomainCommand.prototype.resolveMiddleware = function (clientStack, configuration, options) {
        this.middlewareStack.use(getSerdePlugin(configuration, this.serialize, this.deserialize));
        var stack = clientStack.concat(this.middlewareStack);
        var logger = configuration.logger;
        var clientName = "ElasticsearchServiceClient";
        var commandName = "UpgradeElasticsearchDomainCommand";
        var handlerExecutionContext = {
            logger: logger,
            clientName: clientName,
            commandName: commandName,
            inputFilterSensitiveLog: UpgradeElasticsearchDomainRequest.filterSensitiveLog,
            outputFilterSensitiveLog: UpgradeElasticsearchDomainResponse.filterSensitiveLog,
        };
        var requestHandler = configuration.requestHandler;
        return stack.resolve(function (request) {
            return requestHandler.handle(request.request, options || {});
        }, handlerExecutionContext);
    };
    UpgradeElasticsearchDomainCommand.prototype.serialize = function (input, context) {
        return serializeAws_restJson1UpgradeElasticsearchDomainCommand(input, context);
    };
    UpgradeElasticsearchDomainCommand.prototype.deserialize = function (output, context) {
        return deserializeAws_restJson1UpgradeElasticsearchDomainCommand(output, context);
    };
    return UpgradeElasticsearchDomainCommand;
}($Command));
export { UpgradeElasticsearchDomainCommand };
