import { HttpRequest as __HttpRequest, HttpResponse as __HttpResponse } from "@aws-sdk/protocol-http";
import { SerdeContext as __SerdeContext } from "@aws-sdk/types";
import { AcceptInboundCrossClusterSearchConnectionCommandInput, AcceptInboundCrossClusterSearchConnectionCommandOutput } from "../commands/AcceptInboundCrossClusterSearchConnectionCommand";
import { AddTagsCommandInput, AddTagsCommandOutput } from "../commands/AddTagsCommand";
import { AssociatePackageCommandInput, AssociatePackageCommandOutput } from "../commands/AssociatePackageCommand";
import { CancelElasticsearchServiceSoftwareUpdateCommandInput, CancelElasticsearchServiceSoftwareUpdateCommandOutput } from "../commands/CancelElasticsearchServiceSoftwareUpdateCommand";
import { CreateElasticsearchDomainCommandInput, CreateElasticsearchDomainCommandOutput } from "../commands/CreateElasticsearchDomainCommand";
import { CreateOutboundCrossClusterSearchConnectionCommandInput, CreateOutboundCrossClusterSearchConnectionCommandOutput } from "../commands/CreateOutboundCrossClusterSearchConnectionCommand";
import { CreatePackageCommandInput, CreatePackageCommandOutput } from "../commands/CreatePackageCommand";
import { DeleteElasticsearchDomainCommandInput, DeleteElasticsearchDomainCommandOutput } from "../commands/DeleteElasticsearchDomainCommand";
import { DeleteElasticsearchServiceRoleCommandInput, DeleteElasticsearchServiceRoleCommandOutput } from "../commands/DeleteElasticsearchServiceRoleCommand";
import { DeleteInboundCrossClusterSearchConnectionCommandInput, DeleteInboundCrossClusterSearchConnectionCommandOutput } from "../commands/DeleteInboundCrossClusterSearchConnectionCommand";
import { DeleteOutboundCrossClusterSearchConnectionCommandInput, DeleteOutboundCrossClusterSearchConnectionCommandOutput } from "../commands/DeleteOutboundCrossClusterSearchConnectionCommand";
import { DeletePackageCommandInput, DeletePackageCommandOutput } from "../commands/DeletePackageCommand";
import { DescribeDomainAutoTunesCommandInput, DescribeDomainAutoTunesCommandOutput } from "../commands/DescribeDomainAutoTunesCommand";
import { DescribeDomainChangeProgressCommandInput, DescribeDomainChangeProgressCommandOutput } from "../commands/DescribeDomainChangeProgressCommand";
import { DescribeElasticsearchDomainCommandInput, DescribeElasticsearchDomainCommandOutput } from "../commands/DescribeElasticsearchDomainCommand";
import { DescribeElasticsearchDomainConfigCommandInput, DescribeElasticsearchDomainConfigCommandOutput } from "../commands/DescribeElasticsearchDomainConfigCommand";
import { DescribeElasticsearchDomainsCommandInput, DescribeElasticsearchDomainsCommandOutput } from "../commands/DescribeElasticsearchDomainsCommand";
import { DescribeElasticsearchInstanceTypeLimitsCommandInput, DescribeElasticsearchInstanceTypeLimitsCommandOutput } from "../commands/DescribeElasticsearchInstanceTypeLimitsCommand";
import { DescribeInboundCrossClusterSearchConnectionsCommandInput, DescribeInboundCrossClusterSearchConnectionsCommandOutput } from "../commands/DescribeInboundCrossClusterSearchConnectionsCommand";
import { DescribeOutboundCrossClusterSearchConnectionsCommandInput, DescribeOutboundCrossClusterSearchConnectionsCommandOutput } from "../commands/DescribeOutboundCrossClusterSearchConnectionsCommand";
import { DescribePackagesCommandInput, DescribePackagesCommandOutput } from "../commands/DescribePackagesCommand";
import { DescribeReservedElasticsearchInstanceOfferingsCommandInput, DescribeReservedElasticsearchInstanceOfferingsCommandOutput } from "../commands/DescribeReservedElasticsearchInstanceOfferingsCommand";
import { DescribeReservedElasticsearchInstancesCommandInput, DescribeReservedElasticsearchInstancesCommandOutput } from "../commands/DescribeReservedElasticsearchInstancesCommand";
import { DissociatePackageCommandInput, DissociatePackageCommandOutput } from "../commands/DissociatePackageCommand";
import { GetCompatibleElasticsearchVersionsCommandInput, GetCompatibleElasticsearchVersionsCommandOutput } from "../commands/GetCompatibleElasticsearchVersionsCommand";
import { GetPackageVersionHistoryCommandInput, GetPackageVersionHistoryCommandOutput } from "../commands/GetPackageVersionHistoryCommand";
import { GetUpgradeHistoryCommandInput, GetUpgradeHistoryCommandOutput } from "../commands/GetUpgradeHistoryCommand";
import { GetUpgradeStatusCommandInput, GetUpgradeStatusCommandOutput } from "../commands/GetUpgradeStatusCommand";
import { ListDomainNamesCommandInput, ListDomainNamesCommandOutput } from "../commands/ListDomainNamesCommand";
import { ListDomainsForPackageCommandInput, ListDomainsForPackageCommandOutput } from "../commands/ListDomainsForPackageCommand";
import { ListElasticsearchInstanceTypesCommandInput, ListElasticsearchInstanceTypesCommandOutput } from "../commands/ListElasticsearchInstanceTypesCommand";
import { ListElasticsearchVersionsCommandInput, ListElasticsearchVersionsCommandOutput } from "../commands/ListElasticsearchVersionsCommand";
import { ListPackagesForDomainCommandInput, ListPackagesForDomainCommandOutput } from "../commands/ListPackagesForDomainCommand";
import { ListTagsCommandInput, ListTagsCommandOutput } from "../commands/ListTagsCommand";
import { PurchaseReservedElasticsearchInstanceOfferingCommandInput, PurchaseReservedElasticsearchInstanceOfferingCommandOutput } from "../commands/PurchaseReservedElasticsearchInstanceOfferingCommand";
import { RejectInboundCrossClusterSearchConnectionCommandInput, RejectInboundCrossClusterSearchConnectionCommandOutput } from "../commands/RejectInboundCrossClusterSearchConnectionCommand";
import { RemoveTagsCommandInput, RemoveTagsCommandOutput } from "../commands/RemoveTagsCommand";
import { StartElasticsearchServiceSoftwareUpdateCommandInput, StartElasticsearchServiceSoftwareUpdateCommandOutput } from "../commands/StartElasticsearchServiceSoftwareUpdateCommand";
import { UpdateElasticsearchDomainConfigCommandInput, UpdateElasticsearchDomainConfigCommandOutput } from "../commands/UpdateElasticsearchDomainConfigCommand";
import { UpdatePackageCommandInput, UpdatePackageCommandOutput } from "../commands/UpdatePackageCommand";
import { UpgradeElasticsearchDomainCommandInput, UpgradeElasticsearchDomainCommandOutput } from "../commands/UpgradeElasticsearchDomainCommand";
export declare const serializeAws_restJson1AcceptInboundCrossClusterSearchConnectionCommand: (input: AcceptInboundCrossClusterSearchConnectionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1AddTagsCommand: (input: AddTagsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1AssociatePackageCommand: (input: AssociatePackageCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1CancelElasticsearchServiceSoftwareUpdateCommand: (input: CancelElasticsearchServiceSoftwareUpdateCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1CreateElasticsearchDomainCommand: (input: CreateElasticsearchDomainCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1CreateOutboundCrossClusterSearchConnectionCommand: (input: CreateOutboundCrossClusterSearchConnectionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1CreatePackageCommand: (input: CreatePackageCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1DeleteElasticsearchDomainCommand: (input: DeleteElasticsearchDomainCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1DeleteElasticsearchServiceRoleCommand: (input: DeleteElasticsearchServiceRoleCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1DeleteInboundCrossClusterSearchConnectionCommand: (input: DeleteInboundCrossClusterSearchConnectionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1DeleteOutboundCrossClusterSearchConnectionCommand: (input: DeleteOutboundCrossClusterSearchConnectionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1DeletePackageCommand: (input: DeletePackageCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1DescribeDomainAutoTunesCommand: (input: DescribeDomainAutoTunesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1DescribeDomainChangeProgressCommand: (input: DescribeDomainChangeProgressCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1DescribeElasticsearchDomainCommand: (input: DescribeElasticsearchDomainCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1DescribeElasticsearchDomainConfigCommand: (input: DescribeElasticsearchDomainConfigCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1DescribeElasticsearchDomainsCommand: (input: DescribeElasticsearchDomainsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1DescribeElasticsearchInstanceTypeLimitsCommand: (input: DescribeElasticsearchInstanceTypeLimitsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1DescribeInboundCrossClusterSearchConnectionsCommand: (input: DescribeInboundCrossClusterSearchConnectionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1DescribeOutboundCrossClusterSearchConnectionsCommand: (input: DescribeOutboundCrossClusterSearchConnectionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1DescribePackagesCommand: (input: DescribePackagesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1DescribeReservedElasticsearchInstanceOfferingsCommand: (input: DescribeReservedElasticsearchInstanceOfferingsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1DescribeReservedElasticsearchInstancesCommand: (input: DescribeReservedElasticsearchInstancesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1DissociatePackageCommand: (input: DissociatePackageCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1GetCompatibleElasticsearchVersionsCommand: (input: GetCompatibleElasticsearchVersionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1GetPackageVersionHistoryCommand: (input: GetPackageVersionHistoryCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1GetUpgradeHistoryCommand: (input: GetUpgradeHistoryCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1GetUpgradeStatusCommand: (input: GetUpgradeStatusCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1ListDomainNamesCommand: (input: ListDomainNamesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1ListDomainsForPackageCommand: (input: ListDomainsForPackageCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1ListElasticsearchInstanceTypesCommand: (input: ListElasticsearchInstanceTypesCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1ListElasticsearchVersionsCommand: (input: ListElasticsearchVersionsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1ListPackagesForDomainCommand: (input: ListPackagesForDomainCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1ListTagsCommand: (input: ListTagsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1PurchaseReservedElasticsearchInstanceOfferingCommand: (input: PurchaseReservedElasticsearchInstanceOfferingCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1RejectInboundCrossClusterSearchConnectionCommand: (input: RejectInboundCrossClusterSearchConnectionCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1RemoveTagsCommand: (input: RemoveTagsCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1StartElasticsearchServiceSoftwareUpdateCommand: (input: StartElasticsearchServiceSoftwareUpdateCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1UpdateElasticsearchDomainConfigCommand: (input: UpdateElasticsearchDomainConfigCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1UpdatePackageCommand: (input: UpdatePackageCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const serializeAws_restJson1UpgradeElasticsearchDomainCommand: (input: UpgradeElasticsearchDomainCommandInput, context: __SerdeContext) => Promise<__HttpRequest>;
export declare const deserializeAws_restJson1AcceptInboundCrossClusterSearchConnectionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AcceptInboundCrossClusterSearchConnectionCommandOutput>;
export declare const deserializeAws_restJson1AddTagsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AddTagsCommandOutput>;
export declare const deserializeAws_restJson1AssociatePackageCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<AssociatePackageCommandOutput>;
export declare const deserializeAws_restJson1CancelElasticsearchServiceSoftwareUpdateCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CancelElasticsearchServiceSoftwareUpdateCommandOutput>;
export declare const deserializeAws_restJson1CreateElasticsearchDomainCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateElasticsearchDomainCommandOutput>;
export declare const deserializeAws_restJson1CreateOutboundCrossClusterSearchConnectionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreateOutboundCrossClusterSearchConnectionCommandOutput>;
export declare const deserializeAws_restJson1CreatePackageCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<CreatePackageCommandOutput>;
export declare const deserializeAws_restJson1DeleteElasticsearchDomainCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteElasticsearchDomainCommandOutput>;
export declare const deserializeAws_restJson1DeleteElasticsearchServiceRoleCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteElasticsearchServiceRoleCommandOutput>;
export declare const deserializeAws_restJson1DeleteInboundCrossClusterSearchConnectionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteInboundCrossClusterSearchConnectionCommandOutput>;
export declare const deserializeAws_restJson1DeleteOutboundCrossClusterSearchConnectionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeleteOutboundCrossClusterSearchConnectionCommandOutput>;
export declare const deserializeAws_restJson1DeletePackageCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DeletePackageCommandOutput>;
export declare const deserializeAws_restJson1DescribeDomainAutoTunesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeDomainAutoTunesCommandOutput>;
export declare const deserializeAws_restJson1DescribeDomainChangeProgressCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeDomainChangeProgressCommandOutput>;
export declare const deserializeAws_restJson1DescribeElasticsearchDomainCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeElasticsearchDomainCommandOutput>;
export declare const deserializeAws_restJson1DescribeElasticsearchDomainConfigCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeElasticsearchDomainConfigCommandOutput>;
export declare const deserializeAws_restJson1DescribeElasticsearchDomainsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeElasticsearchDomainsCommandOutput>;
export declare const deserializeAws_restJson1DescribeElasticsearchInstanceTypeLimitsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeElasticsearchInstanceTypeLimitsCommandOutput>;
export declare const deserializeAws_restJson1DescribeInboundCrossClusterSearchConnectionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeInboundCrossClusterSearchConnectionsCommandOutput>;
export declare const deserializeAws_restJson1DescribeOutboundCrossClusterSearchConnectionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeOutboundCrossClusterSearchConnectionsCommandOutput>;
export declare const deserializeAws_restJson1DescribePackagesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribePackagesCommandOutput>;
export declare const deserializeAws_restJson1DescribeReservedElasticsearchInstanceOfferingsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeReservedElasticsearchInstanceOfferingsCommandOutput>;
export declare const deserializeAws_restJson1DescribeReservedElasticsearchInstancesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DescribeReservedElasticsearchInstancesCommandOutput>;
export declare const deserializeAws_restJson1DissociatePackageCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<DissociatePackageCommandOutput>;
export declare const deserializeAws_restJson1GetCompatibleElasticsearchVersionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetCompatibleElasticsearchVersionsCommandOutput>;
export declare const deserializeAws_restJson1GetPackageVersionHistoryCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetPackageVersionHistoryCommandOutput>;
export declare const deserializeAws_restJson1GetUpgradeHistoryCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetUpgradeHistoryCommandOutput>;
export declare const deserializeAws_restJson1GetUpgradeStatusCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<GetUpgradeStatusCommandOutput>;
export declare const deserializeAws_restJson1ListDomainNamesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListDomainNamesCommandOutput>;
export declare const deserializeAws_restJson1ListDomainsForPackageCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListDomainsForPackageCommandOutput>;
export declare const deserializeAws_restJson1ListElasticsearchInstanceTypesCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListElasticsearchInstanceTypesCommandOutput>;
export declare const deserializeAws_restJson1ListElasticsearchVersionsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListElasticsearchVersionsCommandOutput>;
export declare const deserializeAws_restJson1ListPackagesForDomainCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListPackagesForDomainCommandOutput>;
export declare const deserializeAws_restJson1ListTagsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<ListTagsCommandOutput>;
export declare const deserializeAws_restJson1PurchaseReservedElasticsearchInstanceOfferingCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<PurchaseReservedElasticsearchInstanceOfferingCommandOutput>;
export declare const deserializeAws_restJson1RejectInboundCrossClusterSearchConnectionCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<RejectInboundCrossClusterSearchConnectionCommandOutput>;
export declare const deserializeAws_restJson1RemoveTagsCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<RemoveTagsCommandOutput>;
export declare const deserializeAws_restJson1StartElasticsearchServiceSoftwareUpdateCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<StartElasticsearchServiceSoftwareUpdateCommandOutput>;
export declare const deserializeAws_restJson1UpdateElasticsearchDomainConfigCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdateElasticsearchDomainConfigCommandOutput>;
export declare const deserializeAws_restJson1UpdatePackageCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpdatePackageCommandOutput>;
export declare const deserializeAws_restJson1UpgradeElasticsearchDomainCommand: (output: __HttpResponse, context: __SerdeContext) => Promise<UpgradeElasticsearchDomainCommandOutput>;
