import { EndpointsInputConfig, EndpointsResolvedConfig, RegionInputConfig, RegionResolvedConfig } from "@aws-sdk/config-resolver";
import { HostHeaderInputConfig, HostHeaderResolvedConfig } from "@aws-sdk/middleware-host-header";
import { RetryInputConfig, RetryResolvedConfig } from "@aws-sdk/middleware-retry";
import { AwsAuthInputConfig, AwsAuthResolvedConfig } from "@aws-sdk/middleware-signing";
import { UserAgentInputConfig, UserAgentResolvedConfig } from "@aws-sdk/middleware-user-agent";
import { HttpHandler as __HttpHandler } from "@aws-sdk/protocol-http";
import { Client as __Client, DefaultsMode, SmithyConfiguration as __SmithyConfiguration, SmithyResolvedConfiguration as __SmithyResolvedConfiguration } from "@aws-sdk/smithy-client";
import { BodyLengthCalculator as __BodyLengthCalculator, Credentials as __Credentials, Decoder as __Decoder, Encoder as __Encoder, HashConstructor as __HashConstructor, HttpHandlerOptions as __HttpHandlerOptions, Logger as __Logger, Provider as __Provider, Provider, RegionInfoProvider, StreamCollector as __StreamCollector, UrlParser as __UrlParser, UserAgent as __UserAgent } from "@aws-sdk/types";
import { AcceptInboundCrossClusterSearchConnectionCommandInput, AcceptInboundCrossClusterSearchConnectionCommandOutput } from "./commands/AcceptInboundCrossClusterSearchConnectionCommand";
import { AddTagsCommandInput, AddTagsCommandOutput } from "./commands/AddTagsCommand";
import { AssociatePackageCommandInput, AssociatePackageCommandOutput } from "./commands/AssociatePackageCommand";
import { CancelElasticsearchServiceSoftwareUpdateCommandInput, CancelElasticsearchServiceSoftwareUpdateCommandOutput } from "./commands/CancelElasticsearchServiceSoftwareUpdateCommand";
import { CreateElasticsearchDomainCommandInput, CreateElasticsearchDomainCommandOutput } from "./commands/CreateElasticsearchDomainCommand";
import { CreateOutboundCrossClusterSearchConnectionCommandInput, CreateOutboundCrossClusterSearchConnectionCommandOutput } from "./commands/CreateOutboundCrossClusterSearchConnectionCommand";
import { CreatePackageCommandInput, CreatePackageCommandOutput } from "./commands/CreatePackageCommand";
import { DeleteElasticsearchDomainCommandInput, DeleteElasticsearchDomainCommandOutput } from "./commands/DeleteElasticsearchDomainCommand";
import { DeleteElasticsearchServiceRoleCommandInput, DeleteElasticsearchServiceRoleCommandOutput } from "./commands/DeleteElasticsearchServiceRoleCommand";
import { DeleteInboundCrossClusterSearchConnectionCommandInput, DeleteInboundCrossClusterSearchConnectionCommandOutput } from "./commands/DeleteInboundCrossClusterSearchConnectionCommand";
import { DeleteOutboundCrossClusterSearchConnectionCommandInput, DeleteOutboundCrossClusterSearchConnectionCommandOutput } from "./commands/DeleteOutboundCrossClusterSearchConnectionCommand";
import { DeletePackageCommandInput, DeletePackageCommandOutput } from "./commands/DeletePackageCommand";
import { DescribeDomainAutoTunesCommandInput, DescribeDomainAutoTunesCommandOutput } from "./commands/DescribeDomainAutoTunesCommand";
import { DescribeDomainChangeProgressCommandInput, DescribeDomainChangeProgressCommandOutput } from "./commands/DescribeDomainChangeProgressCommand";
import { DescribeElasticsearchDomainCommandInput, DescribeElasticsearchDomainCommandOutput } from "./commands/DescribeElasticsearchDomainCommand";
import { DescribeElasticsearchDomainConfigCommandInput, DescribeElasticsearchDomainConfigCommandOutput } from "./commands/DescribeElasticsearchDomainConfigCommand";
import { DescribeElasticsearchDomainsCommandInput, DescribeElasticsearchDomainsCommandOutput } from "./commands/DescribeElasticsearchDomainsCommand";
import { DescribeElasticsearchInstanceTypeLimitsCommandInput, DescribeElasticsearchInstanceTypeLimitsCommandOutput } from "./commands/DescribeElasticsearchInstanceTypeLimitsCommand";
import { DescribeInboundCrossClusterSearchConnectionsCommandInput, DescribeInboundCrossClusterSearchConnectionsCommandOutput } from "./commands/DescribeInboundCrossClusterSearchConnectionsCommand";
import { DescribeOutboundCrossClusterSearchConnectionsCommandInput, DescribeOutboundCrossClusterSearchConnectionsCommandOutput } from "./commands/DescribeOutboundCrossClusterSearchConnectionsCommand";
import { DescribePackagesCommandInput, DescribePackagesCommandOutput } from "./commands/DescribePackagesCommand";
import { DescribeReservedElasticsearchInstanceOfferingsCommandInput, DescribeReservedElasticsearchInstanceOfferingsCommandOutput } from "./commands/DescribeReservedElasticsearchInstanceOfferingsCommand";
import { DescribeReservedElasticsearchInstancesCommandInput, DescribeReservedElasticsearchInstancesCommandOutput } from "./commands/DescribeReservedElasticsearchInstancesCommand";
import { DissociatePackageCommandInput, DissociatePackageCommandOutput } from "./commands/DissociatePackageCommand";
import { GetCompatibleElasticsearchVersionsCommandInput, GetCompatibleElasticsearchVersionsCommandOutput } from "./commands/GetCompatibleElasticsearchVersionsCommand";
import { GetPackageVersionHistoryCommandInput, GetPackageVersionHistoryCommandOutput } from "./commands/GetPackageVersionHistoryCommand";
import { GetUpgradeHistoryCommandInput, GetUpgradeHistoryCommandOutput } from "./commands/GetUpgradeHistoryCommand";
import { GetUpgradeStatusCommandInput, GetUpgradeStatusCommandOutput } from "./commands/GetUpgradeStatusCommand";
import { ListDomainNamesCommandInput, ListDomainNamesCommandOutput } from "./commands/ListDomainNamesCommand";
import { ListDomainsForPackageCommandInput, ListDomainsForPackageCommandOutput } from "./commands/ListDomainsForPackageCommand";
import { ListElasticsearchInstanceTypesCommandInput, ListElasticsearchInstanceTypesCommandOutput } from "./commands/ListElasticsearchInstanceTypesCommand";
import { ListElasticsearchVersionsCommandInput, ListElasticsearchVersionsCommandOutput } from "./commands/ListElasticsearchVersionsCommand";
import { ListPackagesForDomainCommandInput, ListPackagesForDomainCommandOutput } from "./commands/ListPackagesForDomainCommand";
import { ListTagsCommandInput, ListTagsCommandOutput } from "./commands/ListTagsCommand";
import { PurchaseReservedElasticsearchInstanceOfferingCommandInput, PurchaseReservedElasticsearchInstanceOfferingCommandOutput } from "./commands/PurchaseReservedElasticsearchInstanceOfferingCommand";
import { RejectInboundCrossClusterSearchConnectionCommandInput, RejectInboundCrossClusterSearchConnectionCommandOutput } from "./commands/RejectInboundCrossClusterSearchConnectionCommand";
import { RemoveTagsCommandInput, RemoveTagsCommandOutput } from "./commands/RemoveTagsCommand";
import { StartElasticsearchServiceSoftwareUpdateCommandInput, StartElasticsearchServiceSoftwareUpdateCommandOutput } from "./commands/StartElasticsearchServiceSoftwareUpdateCommand";
import { UpdateElasticsearchDomainConfigCommandInput, UpdateElasticsearchDomainConfigCommandOutput } from "./commands/UpdateElasticsearchDomainConfigCommand";
import { UpdatePackageCommandInput, UpdatePackageCommandOutput } from "./commands/UpdatePackageCommand";
import { UpgradeElasticsearchDomainCommandInput, UpgradeElasticsearchDomainCommandOutput } from "./commands/UpgradeElasticsearchDomainCommand";
export declare type ServiceInputTypes = AcceptInboundCrossClusterSearchConnectionCommandInput | AddTagsCommandInput | AssociatePackageCommandInput | CancelElasticsearchServiceSoftwareUpdateCommandInput | CreateElasticsearchDomainCommandInput | CreateOutboundCrossClusterSearchConnectionCommandInput | CreatePackageCommandInput | DeleteElasticsearchDomainCommandInput | DeleteElasticsearchServiceRoleCommandInput | DeleteInboundCrossClusterSearchConnectionCommandInput | DeleteOutboundCrossClusterSearchConnectionCommandInput | DeletePackageCommandInput | DescribeDomainAutoTunesCommandInput | DescribeDomainChangeProgressCommandInput | DescribeElasticsearchDomainCommandInput | DescribeElasticsearchDomainConfigCommandInput | DescribeElasticsearchDomainsCommandInput | DescribeElasticsearchInstanceTypeLimitsCommandInput | DescribeInboundCrossClusterSearchConnectionsCommandInput | DescribeOutboundCrossClusterSearchConnectionsCommandInput | DescribePackagesCommandInput | DescribeReservedElasticsearchInstanceOfferingsCommandInput | DescribeReservedElasticsearchInstancesCommandInput | DissociatePackageCommandInput | GetCompatibleElasticsearchVersionsCommandInput | GetPackageVersionHistoryCommandInput | GetUpgradeHistoryCommandInput | GetUpgradeStatusCommandInput | ListDomainNamesCommandInput | ListDomainsForPackageCommandInput | ListElasticsearchInstanceTypesCommandInput | ListElasticsearchVersionsCommandInput | ListPackagesForDomainCommandInput | ListTagsCommandInput | PurchaseReservedElasticsearchInstanceOfferingCommandInput | RejectInboundCrossClusterSearchConnectionCommandInput | RemoveTagsCommandInput | StartElasticsearchServiceSoftwareUpdateCommandInput | UpdateElasticsearchDomainConfigCommandInput | UpdatePackageCommandInput | UpgradeElasticsearchDomainCommandInput;
export declare type ServiceOutputTypes = AcceptInboundCrossClusterSearchConnectionCommandOutput | AddTagsCommandOutput | AssociatePackageCommandOutput | CancelElasticsearchServiceSoftwareUpdateCommandOutput | CreateElasticsearchDomainCommandOutput | CreateOutboundCrossClusterSearchConnectionCommandOutput | CreatePackageCommandOutput | DeleteElasticsearchDomainCommandOutput | DeleteElasticsearchServiceRoleCommandOutput | DeleteInboundCrossClusterSearchConnectionCommandOutput | DeleteOutboundCrossClusterSearchConnectionCommandOutput | DeletePackageCommandOutput | DescribeDomainAutoTunesCommandOutput | DescribeDomainChangeProgressCommandOutput | DescribeElasticsearchDomainCommandOutput | DescribeElasticsearchDomainConfigCommandOutput | DescribeElasticsearchDomainsCommandOutput | DescribeElasticsearchInstanceTypeLimitsCommandOutput | DescribeInboundCrossClusterSearchConnectionsCommandOutput | DescribeOutboundCrossClusterSearchConnectionsCommandOutput | DescribePackagesCommandOutput | DescribeReservedElasticsearchInstanceOfferingsCommandOutput | DescribeReservedElasticsearchInstancesCommandOutput | DissociatePackageCommandOutput | GetCompatibleElasticsearchVersionsCommandOutput | GetPackageVersionHistoryCommandOutput | GetUpgradeHistoryCommandOutput | GetUpgradeStatusCommandOutput | ListDomainNamesCommandOutput | ListDomainsForPackageCommandOutput | ListElasticsearchInstanceTypesCommandOutput | ListElasticsearchVersionsCommandOutput | ListPackagesForDomainCommandOutput | ListTagsCommandOutput | PurchaseReservedElasticsearchInstanceOfferingCommandOutput | RejectInboundCrossClusterSearchConnectionCommandOutput | RemoveTagsCommandOutput | StartElasticsearchServiceSoftwareUpdateCommandOutput | UpdateElasticsearchDomainConfigCommandOutput | UpdatePackageCommandOutput | UpgradeElasticsearchDomainCommandOutput;
export interface ClientDefaults extends Partial<__SmithyResolvedConfiguration<__HttpHandlerOptions>> {
    
    requestHandler?: __HttpHandler;
    
    sha256?: __HashConstructor;
    
    urlParser?: __UrlParser;
    
    bodyLengthChecker?: __BodyLengthCalculator;
    
    streamCollector?: __StreamCollector;
    
    base64Decoder?: __Decoder;
    
    base64Encoder?: __Encoder;
    
    utf8Decoder?: __Decoder;
    
    utf8Encoder?: __Encoder;
    
    runtime?: string;
    
    disableHostPrefix?: boolean;
    
    maxAttempts?: number | __Provider<number>;
    
    retryMode?: string | __Provider<string>;
    
    logger?: __Logger;
    
    useDualstackEndpoint?: boolean | __Provider<boolean>;
    
    useFipsEndpoint?: boolean | __Provider<boolean>;
    
    serviceId?: string;
    
    region?: string | __Provider<string>;
    
    credentialDefaultProvider?: (input: any) => __Provider<__Credentials>;
    
    regionInfoProvider?: RegionInfoProvider;
    
    defaultUserAgentProvider?: Provider<__UserAgent>;
    
    defaultsMode?: DefaultsMode | Provider<DefaultsMode>;
}
declare type ElasticsearchServiceClientConfigType = Partial<__SmithyConfiguration<__HttpHandlerOptions>> & ClientDefaults & RegionInputConfig & EndpointsInputConfig & RetryInputConfig & HostHeaderInputConfig & AwsAuthInputConfig & UserAgentInputConfig;

export interface ElasticsearchServiceClientConfig extends ElasticsearchServiceClientConfigType {
}
declare type ElasticsearchServiceClientResolvedConfigType = __SmithyResolvedConfiguration<__HttpHandlerOptions> & Required<ClientDefaults> & RegionResolvedConfig & EndpointsResolvedConfig & RetryResolvedConfig & HostHeaderResolvedConfig & AwsAuthResolvedConfig & UserAgentResolvedConfig;

export interface ElasticsearchServiceClientResolvedConfig extends ElasticsearchServiceClientResolvedConfigType {
}

export declare class ElasticsearchServiceClient extends __Client<__HttpHandlerOptions, ServiceInputTypes, ServiceOutputTypes, ElasticsearchServiceClientResolvedConfig> {
    
    readonly config: ElasticsearchServiceClientResolvedConfig;
    constructor(configuration: ElasticsearchServiceClientConfig);
    
    destroy(): void;
}
export {};
