import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { ElasticsearchServiceClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../ElasticsearchServiceClient";
import { AssociatePackageRequest, AssociatePackageResponse } from "../models/models_0";
export interface AssociatePackageCommandInput extends AssociatePackageRequest {
}
export interface AssociatePackageCommandOutput extends AssociatePackageResponse, __MetadataBearer {
}

export declare class AssociatePackageCommand extends $Command<AssociatePackageCommandInput, AssociatePackageCommandOutput, ElasticsearchServiceClientResolvedConfig> {
    readonly input: AssociatePackageCommandInput;
    constructor(input: AssociatePackageCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: ElasticsearchServiceClientResolvedConfig, options?: __HttpHandlerOptions): Handler<AssociatePackageCommandInput, AssociatePackageCommandOutput>;
    private serialize;
    private deserialize;
}
