import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { ElasticsearchServiceClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../ElasticsearchServiceClient";
import { DescribeDomainChangeProgressRequest, DescribeDomainChangeProgressResponse } from "../models/models_0";
export interface DescribeDomainChangeProgressCommandInput extends DescribeDomainChangeProgressRequest {
}
export interface DescribeDomainChangeProgressCommandOutput extends DescribeDomainChangeProgressResponse, __MetadataBearer {
}

export declare class DescribeDomainChangeProgressCommand extends $Command<DescribeDomainChangeProgressCommandInput, DescribeDomainChangeProgressCommandOutput, ElasticsearchServiceClientResolvedConfig> {
    readonly input: DescribeDomainChangeProgressCommandInput;
    constructor(input: DescribeDomainChangeProgressCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: ElasticsearchServiceClientResolvedConfig, options?: __HttpHandlerOptions): Handler<DescribeDomainChangeProgressCommandInput, DescribeDomainChangeProgressCommandOutput>;
    private serialize;
    private deserialize;
}
