import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { ElasticsearchServiceClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../ElasticsearchServiceClient";
import { DescribePackagesRequest, DescribePackagesResponse } from "../models/models_0";
export interface DescribePackagesCommandInput extends DescribePackagesRequest {
}
export interface DescribePackagesCommandOutput extends DescribePackagesResponse, __MetadataBearer {
}

export declare class DescribePackagesCommand extends $Command<DescribePackagesCommandInput, DescribePackagesCommandOutput, ElasticsearchServiceClientResolvedConfig> {
    readonly input: DescribePackagesCommandInput;
    constructor(input: DescribePackagesCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: ElasticsearchServiceClientResolvedConfig, options?: __HttpHandlerOptions): Handler<DescribePackagesCommandInput, DescribePackagesCommandOutput>;
    private serialize;
    private deserialize;
}
