import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { ElasticsearchServiceClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../ElasticsearchServiceClient";
import { DissociatePackageRequest, DissociatePackageResponse } from "../models/models_0";
export interface DissociatePackageCommandInput extends DissociatePackageRequest {
}
export interface DissociatePackageCommandOutput extends DissociatePackageResponse, __MetadataBearer {
}

export declare class DissociatePackageCommand extends $Command<DissociatePackageCommandInput, DissociatePackageCommandOutput, ElasticsearchServiceClientResolvedConfig> {
    readonly input: DissociatePackageCommandInput;
    constructor(input: DissociatePackageCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: ElasticsearchServiceClientResolvedConfig, options?: __HttpHandlerOptions): Handler<DissociatePackageCommandInput, DissociatePackageCommandOutput>;
    private serialize;
    private deserialize;
}
