import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { ElasticsearchServiceClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../ElasticsearchServiceClient";
import { GetCompatibleElasticsearchVersionsRequest, GetCompatibleElasticsearchVersionsResponse } from "../models/models_0";
export interface GetCompatibleElasticsearchVersionsCommandInput extends GetCompatibleElasticsearchVersionsRequest {
}
export interface GetCompatibleElasticsearchVersionsCommandOutput extends GetCompatibleElasticsearchVersionsResponse, __MetadataBearer {
}

export declare class GetCompatibleElasticsearchVersionsCommand extends $Command<GetCompatibleElasticsearchVersionsCommandInput, GetCompatibleElasticsearchVersionsCommandOutput, ElasticsearchServiceClientResolvedConfig> {
    readonly input: GetCompatibleElasticsearchVersionsCommandInput;
    constructor(input: GetCompatibleElasticsearchVersionsCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: ElasticsearchServiceClientResolvedConfig, options?: __HttpHandlerOptions): Handler<GetCompatibleElasticsearchVersionsCommandInput, GetCompatibleElasticsearchVersionsCommandOutput>;
    private serialize;
    private deserialize;
}
