import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { ElasticsearchServiceClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../ElasticsearchServiceClient";
import { GetPackageVersionHistoryRequest, GetPackageVersionHistoryResponse } from "../models/models_0";
export interface GetPackageVersionHistoryCommandInput extends GetPackageVersionHistoryRequest {
}
export interface GetPackageVersionHistoryCommandOutput extends GetPackageVersionHistoryResponse, __MetadataBearer {
}

export declare class GetPackageVersionHistoryCommand extends $Command<GetPackageVersionHistoryCommandInput, GetPackageVersionHistoryCommandOutput, ElasticsearchServiceClientResolvedConfig> {
    readonly input: GetPackageVersionHistoryCommandInput;
    constructor(input: GetPackageVersionHistoryCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: ElasticsearchServiceClientResolvedConfig, options?: __HttpHandlerOptions): Handler<GetPackageVersionHistoryCommandInput, GetPackageVersionHistoryCommandOutput>;
    private serialize;
    private deserialize;
}
