import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { ElasticsearchServiceClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../ElasticsearchServiceClient";
import { GetUpgradeHistoryRequest, GetUpgradeHistoryResponse } from "../models/models_0";
export interface GetUpgradeHistoryCommandInput extends GetUpgradeHistoryRequest {
}
export interface GetUpgradeHistoryCommandOutput extends GetUpgradeHistoryResponse, __MetadataBearer {
}

export declare class GetUpgradeHistoryCommand extends $Command<GetUpgradeHistoryCommandInput, GetUpgradeHistoryCommandOutput, ElasticsearchServiceClientResolvedConfig> {
    readonly input: GetUpgradeHistoryCommandInput;
    constructor(input: GetUpgradeHistoryCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: ElasticsearchServiceClientResolvedConfig, options?: __HttpHandlerOptions): Handler<GetUpgradeHistoryCommandInput, GetUpgradeHistoryCommandOutput>;
    private serialize;
    private deserialize;
}
