import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { ElasticsearchServiceClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../ElasticsearchServiceClient";
import { GetUpgradeStatusRequest, GetUpgradeStatusResponse } from "../models/models_0";
export interface GetUpgradeStatusCommandInput extends GetUpgradeStatusRequest {
}
export interface GetUpgradeStatusCommandOutput extends GetUpgradeStatusResponse, __MetadataBearer {
}

export declare class GetUpgradeStatusCommand extends $Command<GetUpgradeStatusCommandInput, GetUpgradeStatusCommandOutput, ElasticsearchServiceClientResolvedConfig> {
    readonly input: GetUpgradeStatusCommandInput;
    constructor(input: GetUpgradeStatusCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: ElasticsearchServiceClientResolvedConfig, options?: __HttpHandlerOptions): Handler<GetUpgradeStatusCommandInput, GetUpgradeStatusCommandOutput>;
    private serialize;
    private deserialize;
}
