import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { ElasticsearchServiceClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../ElasticsearchServiceClient";
import { ListDomainNamesRequest, ListDomainNamesResponse } from "../models/models_0";
export interface ListDomainNamesCommandInput extends ListDomainNamesRequest {
}
export interface ListDomainNamesCommandOutput extends ListDomainNamesResponse, __MetadataBearer {
}

export declare class ListDomainNamesCommand extends $Command<ListDomainNamesCommandInput, ListDomainNamesCommandOutput, ElasticsearchServiceClientResolvedConfig> {
    readonly input: ListDomainNamesCommandInput;
    constructor(input: ListDomainNamesCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: ElasticsearchServiceClientResolvedConfig, options?: __HttpHandlerOptions): Handler<ListDomainNamesCommandInput, ListDomainNamesCommandOutput>;
    private serialize;
    private deserialize;
}
