import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { ElasticsearchServiceClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../ElasticsearchServiceClient";
import { ListDomainsForPackageRequest, ListDomainsForPackageResponse } from "../models/models_0";
export interface ListDomainsForPackageCommandInput extends ListDomainsForPackageRequest {
}
export interface ListDomainsForPackageCommandOutput extends ListDomainsForPackageResponse, __MetadataBearer {
}

export declare class ListDomainsForPackageCommand extends $Command<ListDomainsForPackageCommandInput, ListDomainsForPackageCommandOutput, ElasticsearchServiceClientResolvedConfig> {
    readonly input: ListDomainsForPackageCommandInput;
    constructor(input: ListDomainsForPackageCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: ElasticsearchServiceClientResolvedConfig, options?: __HttpHandlerOptions): Handler<ListDomainsForPackageCommandInput, ListDomainsForPackageCommandOutput>;
    private serialize;
    private deserialize;
}
