import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { ElasticsearchServiceClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../ElasticsearchServiceClient";
import { ListElasticsearchInstanceTypesRequest, ListElasticsearchInstanceTypesResponse } from "../models/models_0";
export interface ListElasticsearchInstanceTypesCommandInput extends ListElasticsearchInstanceTypesRequest {
}
export interface ListElasticsearchInstanceTypesCommandOutput extends ListElasticsearchInstanceTypesResponse, __MetadataBearer {
}

export declare class ListElasticsearchInstanceTypesCommand extends $Command<ListElasticsearchInstanceTypesCommandInput, ListElasticsearchInstanceTypesCommandOutput, ElasticsearchServiceClientResolvedConfig> {
    readonly input: ListElasticsearchInstanceTypesCommandInput;
    constructor(input: ListElasticsearchInstanceTypesCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: ElasticsearchServiceClientResolvedConfig, options?: __HttpHandlerOptions): Handler<ListElasticsearchInstanceTypesCommandInput, ListElasticsearchInstanceTypesCommandOutput>;
    private serialize;
    private deserialize;
}
