import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { ElasticsearchServiceClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../ElasticsearchServiceClient";
import { ListPackagesForDomainRequest, ListPackagesForDomainResponse } from "../models/models_0";
export interface ListPackagesForDomainCommandInput extends ListPackagesForDomainRequest {
}
export interface ListPackagesForDomainCommandOutput extends ListPackagesForDomainResponse, __MetadataBearer {
}

export declare class ListPackagesForDomainCommand extends $Command<ListPackagesForDomainCommandInput, ListPackagesForDomainCommandOutput, ElasticsearchServiceClientResolvedConfig> {
    readonly input: ListPackagesForDomainCommandInput;
    constructor(input: ListPackagesForDomainCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: ElasticsearchServiceClientResolvedConfig, options?: __HttpHandlerOptions): Handler<ListPackagesForDomainCommandInput, ListPackagesForDomainCommandOutput>;
    private serialize;
    private deserialize;
}
