import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { ElasticsearchServiceClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../ElasticsearchServiceClient";
import { UpdatePackageRequest, UpdatePackageResponse } from "../models/models_0";
export interface UpdatePackageCommandInput extends UpdatePackageRequest {
}
export interface UpdatePackageCommandOutput extends UpdatePackageResponse, __MetadataBearer {
}

export declare class UpdatePackageCommand extends $Command<UpdatePackageCommandInput, UpdatePackageCommandOutput, ElasticsearchServiceClientResolvedConfig> {
    readonly input: UpdatePackageCommandInput;
    constructor(input: UpdatePackageCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: ElasticsearchServiceClientResolvedConfig, options?: __HttpHandlerOptions): Handler<UpdatePackageCommandInput, UpdatePackageCommandOutput>;
    private serialize;
    private deserialize;
}
