import { Command as $Command } from "@aws-sdk/smithy-client";
import { Handler, HttpHandlerOptions as __HttpHandlerOptions, MetadataBearer as __MetadataBearer, MiddlewareStack } from "@aws-sdk/types";
import { ElasticsearchServiceClientResolvedConfig, ServiceInputTypes, ServiceOutputTypes } from "../ElasticsearchServiceClient";
import { UpgradeElasticsearchDomainRequest, UpgradeElasticsearchDomainResponse } from "../models/models_0";
export interface UpgradeElasticsearchDomainCommandInput extends UpgradeElasticsearchDomainRequest {
}
export interface UpgradeElasticsearchDomainCommandOutput extends UpgradeElasticsearchDomainResponse, __MetadataBearer {
}

export declare class UpgradeElasticsearchDomainCommand extends $Command<UpgradeElasticsearchDomainCommandInput, UpgradeElasticsearchDomainCommandOutput, ElasticsearchServiceClientResolvedConfig> {
    readonly input: UpgradeElasticsearchDomainCommandInput;
    constructor(input: UpgradeElasticsearchDomainCommandInput);
    
    resolveMiddleware(clientStack: MiddlewareStack<ServiceInputTypes, ServiceOutputTypes>, configuration: ElasticsearchServiceClientResolvedConfig, options?: __HttpHandlerOptions): Handler<UpgradeElasticsearchDomainCommandInput, UpgradeElasticsearchDomainCommandOutput>;
    private serialize;
    private deserialize;
}
